stages:
  - BuildArtifact
  - BuildImage
  - DeployCluster
  - CleanUp

build_artifact:
  stage: BuildArtifact
  script:
  - cd devops_sample/project/MavenProject
  - mvn versions:set -DnewVersion=$(../../GenerateNewVersion.sh) -e
  - mvn clean package -e
  artifacts:
    paths:
      - devops_sample/project/MavenProject/*
    expire_in: 60 days
  tags:
    - linux_pc


build_image:
  stage: BuildImage
  dependencies:
    - build_artifact
  script:
  - cd devops_sample
  - docker build -t fake1account/devops_practice:$(./GenerateNewVersion.sh) .
  - docker login -u ${DOCKER_HUB_USERNAME} -p ${DOCKER_HUB_PASSWORD}
  - docker push fake1account/devops_practice:$(./GenerateNewVersion.sh)
  tags:
    - linux_pc

deploy_cluster:
  stage: DeployCluster
  before_script:
    - echo "Start deploying pods!"
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: manual
    - when: on_success
  script:
  - cd app_helm
  - kubectl create namespace $CI_COMMIT_REF_NAME
  - kubectl get namespaces
  - helm install app . -n $CI_COMMIT_REF_NAME
  - cd ../ELK/elasticsearch
  - helm install elk . -n $CI_COMMIT_REF_NAME
  - cd ../../prometheus
  - helm install prom . -n $CI_COMMIT_REF_NAME
  - kubectl get pods -n $CI_COMMIT_REF_NAME
  tags:
    - linux_pc
  
cleanUp:
  stage: CleanUp
  before_script:
    - echo "Start cleaning up!"
  when: manual
  script:
  - helm uninstall app -n $CI_COMMIT_REF_NAME
  - helm uninstall elk -n $CI_COMMIT_REF_NAME
  - helm uninstall prom -n $CI_COMMIT_REF_NAME
  - kubectl get pod -n $CI_COMMIT_REF_NAME
  - kubectl delete namespace $CI_COMMIT_REF_NAME
  - kubectl get namespaces
  tags:
    - linux_pc